diff --git a/src/main/java/net/minecraft/core/block/LampBlock.java b/src/main/java/net/minecraft/core/block/LampBlock.java
index f185e66fc..be09345f7 100644
--- a/src/main/java/net/minecraft/core/block/LampBlock.java
+++ b/src/main/java/net/minecraft/core/block/LampBlock.java
@@ -19,7 +19,7 @@ public class LampBlock extends Block implements IPainted {
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
         if (world.isClientSide) {
             return;
         }
diff --git a/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java b/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
index 0c171535d..1f18fead4 100644
--- a/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
+++ b/src/main/java/net/minecraft/core/block/LeavesLayerBlock.java
@@ -69,22 +69,14 @@ public class LeavesLayerBlock extends BaseLayerBlock
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        func_314_h(world, x, y, z);
-    }
-
-    private boolean func_314_h(World world, int i, int j, int k)
-    {
-        if(!canPlaceBlockAt(world, i, j, k))
-        {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
-            world.setBlockWithNotify(i, j, k, 0);
-            return false;
-        } else
-        {
-            return true;
+        // Remove if no longer valid
+        if (!canPlaceBlockAt(world, x, y, z)) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            world.setBlockWithNotify(x, y, z, 0);
         }
     }
 
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
     {
diff --git a/src/main/java/net/minecraft/core/block/LeverBlock.java b/src/main/java/net/minecraft/core/block/LeverBlock.java
index 81440557e..5f1b849cf 100644
--- a/src/main/java/net/minecraft/core/block/LeverBlock.java
+++ b/src/main/java/net/minecraft/core/block/LeverBlock.java
@@ -72,7 +72,7 @@ public class LeverBlock extends Block
     }
     
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPowered = isPowered(meta);
         int rotation = -1;
@@ -117,7 +117,54 @@ public class LeverBlock extends Block
             world.setBlockMetadataWithNotify(x, y, z, rotation | (isPowered ? MASK_POWERED : 0));
         }
     }
-    
+
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isPowered = isPowered(meta);
+        int rotation = -1;
+        switch (side){
+            case BOTTOM:
+                if (world.canPlaceOnSurfaceOfBlock(x, y + 1, z)){
+                    rotation = ROTATION_BOTTOM_NS;
+                }
+                break;
+            case TOP:
+                if (world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
+                {
+                    rotation = ROTATION_TOP_NS;
+                }
+                break;
+            case NORTH:
+                if (world.isBlockNormalCube(x, y, z + 1)){
+                    rotation = ROTATION_NORTH;
+                }
+                break;
+            case SOUTH:
+                if (world.isBlockNormalCube(x, y, z - 1)){
+                    rotation = ROTATION_SOUTH;
+                }
+                break;
+            case WEST:
+                if (world.isBlockNormalCube(x + 1, y, z)){
+                    rotation = ROTATION_WEST;
+                }
+                break;
+            case EAST:
+                if (world.isBlockNormalCube(x - 1, y, z)){
+                    rotation = ROTATION_EAST;
+                }
+                break;
+        }
+
+        if(rotation == -1) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            world.setBlockWithNotify(x, y, z, 0);
+        } else {
+            world.setBlockMetadataWithNotify(x, y, z, rotation | (isPowered ? MASK_POWERED : 0));
+        }
+    }
+
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
diff --git a/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java b/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
index ede40f130..851902b96 100644
--- a/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
+++ b/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
@@ -40,7 +40,7 @@ public class MobSpawnerBlock extends EntityBlock
     }
 
     @Override
-	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+	public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
     	MobSpawnerBlockEntity tileEntity = (MobSpawnerBlockEntity) world.getBlockEntity(x, y, z);
     	tileEntity.setMobId("none");
     }
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java b/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
index 2734b05ff..1dd83c3d5 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
@@ -11,6 +11,7 @@ import org.jetbrains.annotations.Nullable;
 
 public class PaintedFenceGateBlock extends FenceGateBlock implements IPainted
 {
+	public static final int MASK_COLOR = 0b1111_0000;
 	public PaintedFenceGateBlock(String key, String namespaceId, int id)
 	{
 		super(key, namespaceId, id);
@@ -24,12 +25,12 @@ public class PaintedFenceGateBlock extends FenceGateBlock implements IPainted
 	@Override
 	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
 	{
-		return new ItemStack[] { new ItemStack(this, 1, meta & 0xF0) };
+		return new ItemStack[] { new ItemStack(this, 1, meta & MASK_COLOR) };
 	}
 
 	@Override
 	public DyeColor fromMetadata(int meta) {
-		return DyeColor.colorFromBlockMeta((meta & 0xF0) >> 4);
+		return DyeColor.colorFromBlockMeta((meta & MASK_COLOR) >> 4);
 	}
 
 	@Override
@@ -39,13 +40,13 @@ public class PaintedFenceGateBlock extends FenceGateBlock implements IPainted
 
 	@Override
 	public int stripColorFromMetadata(int meta) {
-		return meta & 0xF;
+		return meta & ~MASK_COLOR;
 	}
 
 	@Override
 	public void removeDye(World world, int x, int y, int z) {
 		final int meta = world.getBlockMetadata(x, y, z);
-		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.FENCE_GATE_PLANKS_OAK.id, meta & 0xF);
+		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.FENCE_GATE_PLANKS_OAK.id, meta & ~MASK_COLOR);
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
index a9508082c..3eb3e0365 100644
--- a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
@@ -23,8 +23,14 @@ public class PaintedSlabBlock extends SlabBlock implements IPainted
 	}
 
 	@Override
-	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-		int meta = mob.getVerticalPlacementDirection(side, sideHeight) == Direction.UP ? 2 : 0;
+	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+		int meta = mob.getVerticalPlacementDirection(side, yPlaced) == Direction.UP ? 2 : 0;
+		world.setBlockMetadataWithNotify(x, y, z, meta | (world.getBlockMetadata(x, y, z) & 0xF0));
+	}
+
+	@Override
+	public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+		int meta = side == Side.TOP ? 2 : 0;
 		world.setBlockMetadataWithNotify(x, y, z, meta | (world.getBlockMetadata(x, y, z) & 0xF0));
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/PressurePlateBlock.java b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
index 0c02f172d..5c6145b66 100644
--- a/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
+++ b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
@@ -16,6 +16,8 @@ import java.util.Random;
 
 public class PressurePlateBlock extends Block
 {
+    public static final int MASK_POWERED = 0b0000_0001;
+    public static final int MASK_CEILING = 0b0000_0010;
     private final Class<? extends Entity> triggerMobClass;
 
 	public PressurePlateBlock(String key, String namespaceId, int id, Class<? extends Entity> mobType, Material material)
@@ -96,7 +98,7 @@ public class PressurePlateBlock extends Block
     {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPressed = isPressed(meta);
-        boolean isCeiling = (meta & 0b10) != 0;
+        boolean isCeiling = onCeiling(meta);
         boolean isSteppedOn = false;
         float f = 0.125F;
         List<Entity> list = world.getEntitiesWithinAABB(triggerMobClass, AABB.getTemporaryBB((float)x + f, y + (isCeiling ? .85f : 0f), (float)z + f, (float)(x + 1) - f, (double)y + (isCeiling ? 1 : 0.25D), (float)(z + 1) - f));;
@@ -106,7 +108,7 @@ public class PressurePlateBlock extends Block
         }
         if(isSteppedOn && !isPressed)
         {
-            world.setBlockMetadataWithNotify(x, y, z, meta | 0b01);
+            world.setBlockMetadataWithNotify(x, y, z, meta | MASK_POWERED);
             world.notifyBlocksOfNeighborChange(x, y, z, id);
             world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
             world.markBlocksDirty(x, y, z, x, y, z);
@@ -114,7 +116,7 @@ public class PressurePlateBlock extends Block
         }
         if(!isSteppedOn && isPressed)
         {
-            world.setBlockMetadataWithNotify(x, y, z, meta & 0b10);
+            world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
             world.notifyBlocksOfNeighborChange(x, y, z, id);
             world.notifyBlocksOfNeighborChange(x, y + (isCeiling ? 1 : -1), z, id);
             world.markBlocksDirty(x, y, z, x, y, z);
@@ -129,7 +131,7 @@ public class PressurePlateBlock extends Block
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        boolean isCeiling = (world.getBlockMetadata(x, y, z) & 0b10) != 0;
+        boolean isCeiling = onCeiling(world.getBlockMetadata(x, y, z));
         if(isPressed(data))
         {
             world.notifyBlocksOfNeighborChange(x, y, z, id);
@@ -143,7 +145,7 @@ public class PressurePlateBlock extends Block
     {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPressed = isPressed(meta);
-        boolean isCeiling = (meta & 0b10) != 0;
+        boolean isCeiling = onCeiling(meta);
         float pixel = 0.0625F;
         if(isPressed)
         {
@@ -173,15 +175,19 @@ public class PressurePlateBlock extends Block
     public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        boolean isCeiling = (meta & 0b10) != 0;
+        boolean isCeiling = onCeiling(meta);
         if(isPressed(world.getBlockMetadata(x, y, z))) {
             return side == (isCeiling ? Side.BOTTOM : Side.TOP);
         } else {
             return false;
         }
     }
-    public boolean isPressed(int meta){
-        return (meta & 0b1) != 0;
+    public static boolean isPressed(int meta){
+        return (meta & MASK_POWERED) != 0;
+    }
+
+    public static boolean onCeiling(int meta) {
+        return (meta & MASK_CEILING) != 0;
     }
 
     @Override
@@ -193,12 +199,12 @@ public class PressurePlateBlock extends Block
     @Override
     public int getPistonPushReaction(World world, int x, int y, int z)
     {
-        return 1;
+        return Material.PISTON_DESTROY_ON_PUSH;
     }
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-        if (!world.canPlaceOnSurfaceOfBlock(x, y - 1 , z) || (side.isHorizontal() && sideHeight > 0.5 && world.isBlockNormalCube(x, y + 1, z))){
-            world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | 0b10);
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        if (!world.canPlaceOnSurfaceOfBlock(x, y - 1 , z) || (side.isHorizontal() && yPlaced > 0.5 && world.isBlockNormalCube(x, y + 1, z))){
+            world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | MASK_CEILING);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/RailBlock.java b/src/main/java/net/minecraft/core/block/RailBlock.java
index 5e5e56937..2ae5815a8 100644
--- a/src/main/java/net/minecraft/core/block/RailBlock.java
+++ b/src/main/java/net/minecraft/core/block/RailBlock.java
@@ -15,6 +15,8 @@ import java.util.ArrayList;
 import java.util.List;
 
 public class RailBlock extends Block {
+    public static final int MASK_DIRECTION = 0b0000_0111;
+    public static final int MASK_POWERED = 0b0000_1000;
     public final boolean isPowered;
 
     public static boolean isRailBlockAt(World world, int x, int y, int z) {
@@ -23,7 +25,7 @@ public class RailBlock extends Block {
     public RailDirection getRailDirection(WorldSource world, int x, int y, int z){
         int meta = world.getBlockMetadata(x, y, z);
         if (isPowered){
-            meta &= 0b111;
+            meta &= MASK_DIRECTION;
         }
         return RailDirection.getFromMeta(meta);
     }
@@ -90,7 +92,7 @@ public class RailBlock extends Block {
             return;
         }
         int meta = world.getBlockMetadata(x, y, z);
-        boolean isPoweredFlagSet = (meta & 0b1000) != 0;
+        boolean isPoweredFlagSet = (meta & MASK_POWERED) != 0;
         RailDirection railDirection = getRailDirection(world, x, y, z);
 
         if(!isValidState(world, x, y, z)) {
@@ -111,7 +113,7 @@ public class RailBlock extends Block {
             boolean changedMeta = false;
             if(gettingPower && !isPoweredFlagSet) {
                 // Set powered bit
-                world.setBlockMetadataWithNotify(x, y, z, railDirection.meta | 0b1000);
+                world.setBlockMetadataWithNotify(x, y, z, railDirection.meta | MASK_POWERED);
                 changedMeta = true;
             } else if(!gettingPower && isPoweredFlagSet) {
                 // Remove powered bit
@@ -198,7 +200,7 @@ public class RailBlock extends Block {
         int blockId = world.getBlockId(x, y, z);
         if(blockId == Blocks.RAIL_POWERED.id) {
             int meta = world.getBlockMetadata(x, y, z);
-            boolean isPoweredFlagSet = (meta & 0b1000) != 0;
+            boolean isPoweredFlagSet = (meta & MASK_POWERED) != 0;
             RailDirection direction = getRailDirection(world, x, y, z);
 
             // Return false for perpendicular powered rails
@@ -230,7 +232,7 @@ public class RailBlock extends Block {
     @Override
     public int getPistonPushReaction(World world, int x, int y, int z)
     {
-        return 0;
+        return Material.PISTON_PUSHABLE;
     }
     public static class Rail {
         private final World world;
@@ -431,7 +433,7 @@ public class RailBlock extends Block {
 
             int newMeta = railType.meta;
             if(isPoweredRail) {
-                newMeta |= world.getBlockMetadata(x, y, z) & 0b1000;
+                newMeta |= world.getBlockMetadata(x, y, z) & MASK_POWERED;
             }
 
             if(forceUpdate || world.getBlockMetadata(x, y, z) != newMeta) {
@@ -497,7 +499,7 @@ public class RailBlock extends Block {
             }
             int newMeta = railDirection.meta;
             if(isPoweredRail) {
-                newMeta |= world.getBlockMetadata(x, y, z) & 0b1000;
+                newMeta |= world.getBlockMetadata(x, y, z) & MASK_POWERED;
             }
             world.setBlockMetadataWithNotify(x, y, z, newMeta);
         }
diff --git a/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java b/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
index 4bbcadfb4..73f2ae871 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
@@ -63,12 +63,12 @@ public class RedstoneOreBlock extends Block
     }
 
 
-    private void lightRedstone(World world, int i, int j, int k)
+    private void lightRedstone(World world, int x, int y, int z)
     {
-        spawnParticles(world, i, j, k);
+        spawnParticles(world, x, y, z);
         if (!illuminated)
         {
-        	world.setBlockWithNotify(i, j, k, illuminatedBlock.get().id);
+        	world.setBlockWithNotify(x, y, z, illuminatedBlock.get().id);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java b/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
index f94f02372..e7e93cabd 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneTorchBlock.java
@@ -27,7 +27,7 @@ public class RedstoneTorchBlock extends TorchBlock {
 
     @Override
     public void onBlockPlacedByWorld(World world, int x, int y, int z) {
-        if (world.getBlockMetadata(x, y, z) == 0) {
+        if (world.getBlockMetadata(x, y, z) == SIDE_NONE) {
             super.onBlockPlacedByWorld(world, x, y, z);
         }
         if (torchActive) {
@@ -57,37 +57,38 @@ public class RedstoneTorchBlock extends TorchBlock {
         if (!torchActive) {
             return false;
         }
-        int meta = worldSource.getBlockMetadata(x, y, z);
-        if (meta == 5 && side == Side.TOP) {
-            return false;
-        }
-        if (meta == 3 && side == Side.SOUTH) {
-            return false;
-        }
-        if (meta == 4 && side == Side.NORTH) {
-            return false;
-        }
-        if (meta == 1 && side == Side.EAST) {
-            return false;
-        }
-        return meta != 2 || side != Side.WEST;
+        int direction = worldSource.getBlockMetadata(x, y, z) & MASK_DIRECTION;
+        switch (direction) {
+            case SIDE_BOTTOM:
+                return side != Side.TOP;
+            case SIDE_SOUTH:
+                return side != Side.NORTH;
+            case SIDE_NORTH:
+                return side != Side.SOUTH;
+            case SIDE_EAST:
+                return side != Side.WEST;
+            case SIDE_WEST:
+                return side != Side.EAST;
+        }
+        return false;
     }
 
     private boolean hasNeighborSignal(World world, int x, int y, int z) {
-        int meta = world.getBlockMetadata(x, y, z);
-        if (meta == 5 && world.getSignal(x, y - 1, z, Side.BOTTOM)) {
-            return true;
-        }
-        if (meta == 3 && world.getSignal(x, y, z - 1, Side.NORTH)) {
-            return true;
+        int direction = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
+        switch (direction) {
+            case SIDE_BOTTOM:
+                return world.getSignal(x, y - 1, z, Side.BOTTOM);
+            case SIDE_SOUTH:
+                return world.getSignal(x, y, z + 1, Side.SOUTH);
+            case SIDE_NORTH:
+                return world.getSignal(x, y, z - 1, Side.NORTH);
+            case SIDE_EAST:
+                return world.getSignal(x + 1, y, z, Side.EAST);
+            case SIDE_WEST:
+                return world.getSignal(x - 1, y, z, Side.WEST);
+            default:
+                return false;
         }
-        if (meta == 4 && world.getSignal(x, y, z + 1, Side.SOUTH)) {
-            return true;
-        }
-        if (meta == 1 && world.getSignal(x - 1, y, z, Side.WEST)) {
-            return true;
-        }
-        return meta == 2 && world.getSignal(x + 1, y, z, Side.EAST);
     }
 
     @Override
@@ -133,7 +134,7 @@ public class RedstoneTorchBlock extends TorchBlock {
             return;
         }
 
-        int meta = world.getBlockMetadata(x, y, z);
+        int direction = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
         double px = (x + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
         double py = (y + 0.7D) + (rand.nextFloat() - 0.5D) * 0.2D;
         double pz = (z + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
@@ -150,16 +151,22 @@ public class RedstoneTorchBlock extends TorchBlock {
         float green = color.getGreen() / 255.0f;
         float blue = color.getBlue() / 255.0f;
 
-        if (meta == 1) {
-            world.spawnParticle("reddust", px - horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
-        } else if (meta == 2) {
-            world.spawnParticle("reddust", px + horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
-        } else if (meta == 3) {
-            world.spawnParticle("reddust", px, py + verticalOffset, pz - horizontalOffset, red, green, blue, redstoneBrightness);
-        } else if (meta == 4) {
-            world.spawnParticle("reddust", px, py + verticalOffset, pz + horizontalOffset, red, green, blue, redstoneBrightness);
-        } else {
-            world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
+        switch (direction) {
+            case SIDE_WEST:
+                world.spawnParticle("reddust", px - horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
+                break;
+            case SIDE_EAST:
+                world.spawnParticle("reddust", px + horizontalOffset, py + verticalOffset, pz, red, green, blue, redstoneBrightness);
+                break;
+            case SIDE_NORTH:
+                world.spawnParticle("reddust", px, py + verticalOffset, pz - horizontalOffset, red, green, blue, redstoneBrightness);
+                break;
+            case SIDE_SOUTH:
+                world.spawnParticle("reddust", px, py + verticalOffset, pz + horizontalOffset, red, green, blue, redstoneBrightness);
+                break;
+            case SIDE_BOTTOM:
+                world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
+                break;
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/RepeaterBlock.java b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
index cd036866e..da3bc9e00 100644
--- a/src/main/java/net/minecraft/core/block/RepeaterBlock.java
+++ b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -165,7 +166,7 @@ public class RepeaterBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
 		int l = mob.getHorizontalPlacementDirection(side).index;
 		world.setBlockMetadataWithNotify(x, y, z, l);
 		boolean flag = isGettingPower(world, x, y, z, l);
@@ -175,6 +176,18 @@ public class RepeaterBlock extends Block
 		}
     }
 
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        if (!side.isHorizontal()) side = Side.NORTH;
+        int l = side.getDirection().index;
+        world.setBlockMetadataWithNotify(x, y, z, l);
+        boolean flag = isGettingPower(world, x, y, z, l);
+        if(flag)
+        {
+            world.scheduleBlockUpdate(x, y, z, id, 1);
+        }
+    }
+
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
diff --git a/src/main/java/net/minecraft/core/block/RopeBlock.java b/src/main/java/net/minecraft/core/block/RopeBlock.java
index 967e5ed96..c204db867 100644
--- a/src/main/java/net/minecraft/core/block/RopeBlock.java
+++ b/src/main/java/net/minecraft/core/block/RopeBlock.java
@@ -15,6 +15,7 @@ import net.minecraft.core.world.WorldSource;
 
 public class RopeBlock
     extends Block {
+    public static final int MASK_ROPE_CONNECT = 0b1000_0000;
     public RopeBlock(String key, String namespaceId, int id) {
         super(key, namespaceId,id, Material.cloth);
     }
@@ -72,8 +73,8 @@ public class RopeBlock
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ToolShearsItem) {
             int meta = world.getBlockMetadata(x, y, z);
-            int forceRope = (~meta) & 0b1000_0000;
-            world.setBlockMetadataWithNotify(x, y, z, forceRope | (meta & 0b0111_1111));
+            int forceRope = (~meta) & MASK_ROPE_CONNECT;
+            world.setBlockMetadataWithNotify(x, y, z, forceRope | (meta & ~MASK_ROPE_CONNECT));
             heldItem.damageItem(1, player);
             if (heldItem.stackSize <= 0){
                 player.destroyCurrentEquippedItem();
diff --git a/src/main/java/net/minecraft/core/block/RotatableBlock.java b/src/main/java/net/minecraft/core/block/RotatableBlock.java
index 6c6972c9e..679dc3e81 100644
--- a/src/main/java/net/minecraft/core/block/RotatableBlock.java
+++ b/src/main/java/net/minecraft/core/block/RotatableBlock.java
@@ -5,6 +5,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import org.jetbrains.annotations.NotNull;
 
 public abstract class RotatableBlock extends Block{
@@ -13,36 +14,6 @@ public abstract class RotatableBlock extends Block{
         super(key, namespaceId, id, material);
     }
 
-    public void setDefaultDirection(World world, int x, int y, int z)
-    {
-        if(world.isClientSide)
-        {
-            return;
-        }
-        int idNegZ = world.getBlockId(x, y, z - 1);
-        int idPosZ = world.getBlockId(x, y, z + 1);
-        int idNegX = world.getBlockId(x - 1, y, z);
-        int idPosX = world.getBlockId(x + 1, y, z);
-        Direction direction = Direction.SOUTH;
-        if(Block.solid[idNegZ] && !Block.solid[idPosZ])
-        {
-            direction = Direction.SOUTH;
-        }
-        if(Block.solid[idPosZ] && !Block.solid[idNegZ])
-        {
-            direction = Direction.NORTH;
-        }
-        if(Block.solid[idNegX] && !Block.solid[idPosX])
-        {
-            direction = Direction.EAST;
-        }
-        if(Block.solid[idPosX] && !Block.solid[idNegX])
-        {
-            direction = Direction.WEST;
-        }
-        world.setBlockMetadataWithNotify(x, y, z, setDirection(0, direction));
-    }
-
     public static Direction getDirectionFromMeta(int meta)
     {
         return Direction.getDirectionById(meta & MASK_DIRECTION);
@@ -53,14 +24,20 @@ public abstract class RotatableBlock extends Block{
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
         world.setBlockMetadataWithNotify(x, y, z, mob.getHorizontalPlacementDirection(side).getOpposite().getId());
     }
 
     @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        if (!side.isHorizontal()) side = Side.NORTH;
+        world.setBlockMetadataWithNotify(x, y, z, side.getOpposite().getId());
+    }
+
+    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction)
     {
-        super.onBlockPlacedByWorld(world, x, y, z);
-        setDefaultDirection(world, x, y, z);
+        super.onBlockPlacedByActivator(world, x, y, z, activator, direction);
+        if (direction.getOffsetY() != 0) direction = Direction.NORTH.getOpposite();
+        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
     }
 }
